﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2022.1.3),
    on Thu Jul  7 10:55:23 2022
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

from psychopy import locale_setup
from psychopy import prefs
from psychopy import sound, gui, visual, core, data, event, logging, clock, colors, layout
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle, choice as randchoice
import os  # handy system and path functions
import sys  # to get file system encoding

import psychopy.iohub as io
from psychopy.hardware import keyboard



# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)
# Store info about the experiment session
psychopyVersion = '2022.1.3'
expName = '0-back'  # from the Builder filename that created this script
expInfo = {'Subject ID': '', 'Session #': ''}
dlg = gui.DlgFromDict(dictionary=expInfo, sortKeys=False, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['Subject ID'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='/Users/emmalaurent/Desktop/grad/projects/replayInterference/experiments/0-Back/D1_AAA_0B/D1_AAA_0B_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.DEBUG)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run after the window creation

# Setup the Window
win = visual.Window(
    size=[1792, 1120], fullscr=True, screen=0, 
    winType='pyglet', allowGUI=False, allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb',
    blendMode='avg', useFBO=True, 
    units='norm')
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess
# Setup ioHub
ioConfig = {}

# Setup iohub keyboard
ioConfig['Keyboard'] = dict(use_keymap='psychopy')

ioSession = '1'
if 'session' in expInfo:
    ioSession = str(expInfo['session'])
ioServer = io.launchHubServer(window=win, **ioConfig)
eyetracker = None

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard(backend='iohub')

# Initialize components for Routine "instruct"
instructClock = core.Clock()
whiteBackground = visual.Rect(
    win=win, name='whiteBackground',units='norm', 
    width=(2, 2)[0], height=(2, 2)[1],
    ori=0.0, pos=(0, 0), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='white', fillColor='white',
    opacity=None, depth=0.0, interpolate=True)
instructionsImage = visual.ImageStim(
    win=win,
    name='instructionsImage', units='height', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(1.6, 0.9),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-1.0)
key_resp = keyboard.Keyboard()
instructN = 1

maxInstructN = 14
minInstructN = 1

# Initialize components for Routine "compCheck"
compCheckClock = core.Clock()
compCheck_txt = visual.TextStim(win=win, name='compCheck_txt',
    text='You have reached the end of the instructions.\n\nPlease let the researcher(s) know that you are ready to begin the comprehension check!',
    font='Arial',
    units='norm', pos=(0, 0), height=0.12, wrapWidth=1.8, ori=0.0, 
    color=[-0.6500, -0.6500, -0.6500], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
compCheck_button = keyboard.Keyboard()

# Initialize components for Routine "prep_nBack"
prep_nBackClock = core.Clock()
prep_nBack_text = visual.TextStim(win=win, name='prep_nBack_text',
    text='You will now complete the 0-Back Task. \n\nWhen you see the target letter, press the right arrow key; otherwise, press the left arrow key.\n\nPress the spacebar when you are ready to begin.',
    font='Arial',
    pos=(0, 0), height=0.11, wrapWidth=1.6, ori=0.0, 
    color=[-0.6500, -0.6500, -0.6500], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
prep_nBack_key_resp = keyboard.Keyboard()

# Initialize components for Routine "target_nBack"
target_nBackClock = core.Clock()
block1_polygon = visual.ShapeStim(
    win=win, name='block1_polygon',
    size=(0.12, 0.19), vertices='circle',
    ori=0.0, pos=(0.82, 0.77), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor=[0.3255, 0.3255, 0.3255], fillColor=[0.3255, 0.3255, 0.3255],
    opacity=None, depth=0.0, interpolate=True)
block1_text1 = visual.TextStim(win=win, name='block1_text1',
    text='The target for this block is:',
    font='Arial',
    pos=(0, 0.5), height=0.15, wrapWidth=2.0, ori=0.0, 
    color=[-0.6500, -0.6500, -0.6500], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
block1_text2 = visual.TextStim(win=win, name='block1_text2',
    text=str(blockTarget),
    font='Arial',
    pos=(0, 0), height=0.5, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);
block1_countdown_3 = visual.TextStim(win=win, name='block1_countdown_3',
    text='3',
    font='Helvetica',
    pos=(0.82, 0.77), height=0.15, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-3.0);
block1_countdown_2 = visual.TextStim(win=win, name='block1_countdown_2',
    text='2',
    font='Helvetica',
    pos=(0.82, 0.77), height=0.15, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-4.0);
block1_countdown_1 = visual.TextStim(win=win, name='block1_countdown_1',
    text='1',
    font='Helvetica',
    pos=(0.82, 0.77), height=0.15, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-5.0);

# Initialize components for Routine "trial_nBack"
trial_nBackClock = core.Clock()
fixation = visual.TextStim(win=win, name='fixation',
    text='+',
    font='Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0.0, 
    color=[0.3255, 0.3255, 0.3255], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
letter_text = visual.TextStim(win=win, name='letter_text',
    text='',
    font='Arial',
    pos=(0, 0), height=0.5, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
response_nBack = keyboard.Keyboard()

# Initialize components for Routine "target_block2"
target_block2Clock = core.Clock()
block2_polygon = visual.ShapeStim(
    win=win, name='block2_polygon',
    size=(0.12, 0.19), vertices='circle',
    ori=0.0, pos=(0.82, 0.77), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor=[0.3255, 0.3255, 0.3255], fillColor=[0.3255, 0.3255, 0.3255],
    opacity=None, depth=0.0, interpolate=True)
block2_text1 = visual.TextStim(win=win, name='block2_text1',
    text='The target for this block is:',
    font='Arial',
    pos=(0, 0.5), height=0.15, wrapWidth=None, ori=0.0, 
    color=[-0.6500, -0.6500, -0.6500], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
block2_text2 = visual.TextStim(win=win, name='block2_text2',
    text='Y',
    font='Arial',
    pos=(0, 0), height=0.5, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);
block1_countdown = visual.TextStim(win=win, name='block1_countdown',
    text='3',
    font='Helvetica',
    pos=(0.82, 0.77), height=0.15, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-3.0);
block1_countdown_4 = visual.TextStim(win=win, name='block1_countdown_4',
    text='2',
    font='Helvetica',
    pos=(0.82, 0.77), height=0.15, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-4.0);
block1_countdown_5 = visual.TextStim(win=win, name='block1_countdown_5',
    text='1',
    font='Helvetica',
    pos=(0.82, 0.77), height=0.15, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-5.0);

# Initialize components for Routine "trial_nBack"
trial_nBackClock = core.Clock()
fixation = visual.TextStim(win=win, name='fixation',
    text='+',
    font='Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0.0, 
    color=[0.3255, 0.3255, 0.3255], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
letter_text = visual.TextStim(win=win, name='letter_text',
    text='',
    font='Arial',
    pos=(0, 0), height=0.5, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
response_nBack = keyboard.Keyboard()

# Initialize components for Routine "target_block3"
target_block3Clock = core.Clock()
block3_polygon = visual.ShapeStim(
    win=win, name='block3_polygon',
    size=(0.12, 0.19), vertices='circle',
    ori=0.0, pos=(0.82, 0.77), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor=[0.3255, 0.3255, 0.3255], fillColor=[0.3255, 0.3255, 0.3255],
    opacity=None, depth=0.0, interpolate=True)
block3_text1 = visual.TextStim(win=win, name='block3_text1',
    text='The target for this block is:',
    font='Arial',
    pos=(0, 0.5), height=0.15, wrapWidth=2.0, ori=0.0, 
    color=[-0.6500, -0.6500, -0.6500], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
block3_text2 = visual.TextStim(win=win, name='block3_text2',
    text='J',
    font='Arial',
    pos=(0, 0), height=0.5, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);
block3_countdown_3 = visual.TextStim(win=win, name='block3_countdown_3',
    text='3',
    font='Helvetica',
    pos=(0.82, 0.77), height=0.15, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-3.0);
block3_countdown_2 = visual.TextStim(win=win, name='block3_countdown_2',
    text='2',
    font='Helvetica',
    pos=(0.82, 0.77), height=0.15, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-4.0);
block3_countdown_1 = visual.TextStim(win=win, name='block3_countdown_1',
    text='1',
    font='Helvetica',
    pos=(0.82, 0.77), height=0.15, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-5.0);

# Initialize components for Routine "trial_nBack"
trial_nBackClock = core.Clock()
fixation = visual.TextStim(win=win, name='fixation',
    text='+',
    font='Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0.0, 
    color=[0.3255, 0.3255, 0.3255], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
letter_text = visual.TextStim(win=win, name='letter_text',
    text='',
    font='Arial',
    pos=(0, 0), height=0.5, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
response_nBack = keyboard.Keyboard()

# Initialize components for Routine "target_block4"
target_block4Clock = core.Clock()
block4_polygon = visual.ShapeStim(
    win=win, name='block4_polygon',
    size=(0.12, 0.19), vertices='circle',
    ori=0.0, pos=(0.82, 0.77), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor=[0.3255, 0.3255, 0.3255], fillColor=[0.3255, 0.3255, 0.3255],
    opacity=None, depth=0.0, interpolate=True)
block4_text1 = visual.TextStim(win=win, name='block4_text1',
    text='The target for this block is:',
    font='Arial',
    pos=(0, 0.5), height=0.15, wrapWidth=2.0, ori=0.0, 
    color=[-0.6500, -0.6500, -0.6500], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
block4_text2 = visual.TextStim(win=win, name='block4_text2',
    text='N',
    font='Arial',
    pos=(0, 0), height=0.5, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);
block4_countdown_3 = visual.TextStim(win=win, name='block4_countdown_3',
    text='3',
    font='Helvetica',
    pos=(0.82, 0.77), height=0.15, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-3.0);
block4_countdown_2 = visual.TextStim(win=win, name='block4_countdown_2',
    text='2',
    font='Helvetica',
    pos=(0.82, 0.77), height=0.15, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-4.0);
block4_countdown_1 = visual.TextStim(win=win, name='block4_countdown_1',
    text='1',
    font='Helvetica',
    pos=(0.82, 0.77), height=0.15, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-5.0);

# Initialize components for Routine "trial_nBack"
trial_nBackClock = core.Clock()
fixation = visual.TextStim(win=win, name='fixation',
    text='+',
    font='Arial',
    pos=(0, 0), height=0.4, wrapWidth=None, ori=0.0, 
    color=[0.3255, 0.3255, 0.3255], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
letter_text = visual.TextStim(win=win, name='letter_text',
    text='',
    font='Arial',
    pos=(0, 0), height=0.5, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
response_nBack = keyboard.Keyboard()

# Initialize components for Routine "thanks"
thanksClock = core.Clock()
expClock = core.Clock()
text = visual.TextStim(win=win, name='text',
    text='',
    font='Arial',
    pos=(0, 0), height=0.09, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# set up handler to look after randomisation of conditions etc
instructions = data.TrialHandler(nReps=1000.0, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='instructions')
thisExp.addLoop(instructions)  # add the loop to the experiment
thisInstruction = instructions.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisInstruction.rgb)
if thisInstruction != None:
    for paramName in thisInstruction:
        exec('{} = thisInstruction[paramName]'.format(paramName))

for thisInstruction in instructions:
    currentLoop = instructions
    # abbreviate parameter names if possible (e.g. rgb = thisInstruction.rgb)
    if thisInstruction != None:
        for paramName in thisInstruction:
            exec('{} = thisInstruction[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "instruct"-------
    continueRoutine = True
    # update component parameters for each repeat
    instructionsImage.setImage('./instructions/instruct' + str(instructN) + '.jpg')
    key_resp.keys = []
    key_resp.rt = []
    _key_resp_allKeys = []
    # keep track of which components have finished
    instructComponents = [whiteBackground, instructionsImage, key_resp]
    for thisComponent in instructComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    instructClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "instruct"-------
    while continueRoutine:
        # get current time
        t = instructClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=instructClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *whiteBackground* updates
        if whiteBackground.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            whiteBackground.frameNStart = frameN  # exact frame index
            whiteBackground.tStart = t  # local t and not account for scr refresh
            whiteBackground.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(whiteBackground, 'tStartRefresh')  # time at next scr refresh
            whiteBackground.setAutoDraw(True)
        
        # *instructionsImage* updates
        if instructionsImage.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            instructionsImage.frameNStart = frameN  # exact frame index
            instructionsImage.tStart = t  # local t and not account for scr refresh
            instructionsImage.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(instructionsImage, 'tStartRefresh')  # time at next scr refresh
            instructionsImage.setAutoDraw(True)
        
        # *key_resp* updates
        waitOnFlip = False
        if key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            key_resp.frameNStart = frameN  # exact frame index
            key_resp.tStart = t  # local t and not account for scr refresh
            key_resp.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_resp, 'tStartRefresh')  # time at next scr refresh
            key_resp.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_resp.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if key_resp.status == STARTED and not waitOnFlip:
            theseKeys = key_resp.getKeys(keyList=['left','right','space'], waitRelease=False)
            _key_resp_allKeys.extend(theseKeys)
            if len(_key_resp_allKeys):
                key_resp.keys = _key_resp_allKeys[-1].name  # just the last key pressed
                key_resp.rt = _key_resp_allKeys[-1].rt
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in instructComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "instruct"-------
    for thisComponent in instructComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    instructions.addData('whiteBackground.started', whiteBackground.tStartRefresh)
    instructions.addData('whiteBackground.stopped', whiteBackground.tStopRefresh)
    instructions.addData('instructionsImage.started', instructionsImage.tStartRefresh)
    instructions.addData('instructionsImage.stopped', instructionsImage.tStopRefresh)
    # check responses
    if key_resp.keys in ['', [], None]:  # No response was made
        key_resp.keys = None
    instructions.addData('key_resp.keys',key_resp.keys)
    if key_resp.keys != None:  # we had a response
        instructions.addData('key_resp.rt', key_resp.rt)
    instructions.addData('key_resp.started', key_resp.tStartRefresh)
    instructions.addData('key_resp.stopped', key_resp.tStopRefresh)
    if key_resp.keys == 'left':
        instructN -= 1
    elif key_resp.keys == 'right':
        instructN += 1
    elif key_resp.keys == 'space':
        if instructN == maxInstructN:
            loop_instruct.finished = True
    
    if instructN > maxInstructN :
        instructN = maxInstructN
    if instructN < minInstructN :
        instructN = minInstructN
    # the Routine "instruct" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
# completed 1000.0 repeats of 'instructions'


# ------Prepare to start Routine "compCheck"-------
continueRoutine = True
# update component parameters for each repeat
compCheck_button.keys = []
compCheck_button.rt = []
_compCheck_button_allKeys = []
# keep track of which components have finished
compCheckComponents = [compCheck_txt, compCheck_button]
for thisComponent in compCheckComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
compCheckClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "compCheck"-------
while continueRoutine:
    # get current time
    t = compCheckClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=compCheckClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *compCheck_txt* updates
    if compCheck_txt.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        compCheck_txt.frameNStart = frameN  # exact frame index
        compCheck_txt.tStart = t  # local t and not account for scr refresh
        compCheck_txt.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(compCheck_txt, 'tStartRefresh')  # time at next scr refresh
        compCheck_txt.setAutoDraw(True)
    
    # *compCheck_button* updates
    waitOnFlip = False
    if compCheck_button.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        compCheck_button.frameNStart = frameN  # exact frame index
        compCheck_button.tStart = t  # local t and not account for scr refresh
        compCheck_button.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(compCheck_button, 'tStartRefresh')  # time at next scr refresh
        compCheck_button.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(compCheck_button.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(compCheck_button.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if compCheck_button.status == STARTED and not waitOnFlip:
        theseKeys = compCheck_button.getKeys(keyList=['a'], waitRelease=False)
        _compCheck_button_allKeys.extend(theseKeys)
        if len(_compCheck_button_allKeys):
            compCheck_button.keys = _compCheck_button_allKeys[-1].name  # just the last key pressed
            compCheck_button.rt = _compCheck_button_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in compCheckComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "compCheck"-------
for thisComponent in compCheckComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('compCheck_txt.started', compCheck_txt.tStartRefresh)
thisExp.addData('compCheck_txt.stopped', compCheck_txt.tStopRefresh)
# check responses
if compCheck_button.keys in ['', [], None]:  # No response was made
    compCheck_button.keys = None
thisExp.addData('compCheck_button.keys',compCheck_button.keys)
if compCheck_button.keys != None:  # we had a response
    thisExp.addData('compCheck_button.rt', compCheck_button.rt)
thisExp.addData('compCheck_button.started', compCheck_button.tStartRefresh)
thisExp.addData('compCheck_button.stopped', compCheck_button.tStopRefresh)
thisExp.nextEntry()
# the Routine "compCheck" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "prep_nBack"-------
continueRoutine = True
# update component parameters for each repeat
prep_nBack_key_resp.keys = []
prep_nBack_key_resp.rt = []
_prep_nBack_key_resp_allKeys = []
# keep track of which components have finished
prep_nBackComponents = [prep_nBack_text, prep_nBack_key_resp]
for thisComponent in prep_nBackComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
prep_nBackClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "prep_nBack"-------
while continueRoutine:
    # get current time
    t = prep_nBackClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=prep_nBackClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *prep_nBack_text* updates
    if prep_nBack_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        prep_nBack_text.frameNStart = frameN  # exact frame index
        prep_nBack_text.tStart = t  # local t and not account for scr refresh
        prep_nBack_text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(prep_nBack_text, 'tStartRefresh')  # time at next scr refresh
        prep_nBack_text.setAutoDraw(True)
    
    # *prep_nBack_key_resp* updates
    waitOnFlip = False
    if prep_nBack_key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        prep_nBack_key_resp.frameNStart = frameN  # exact frame index
        prep_nBack_key_resp.tStart = t  # local t and not account for scr refresh
        prep_nBack_key_resp.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(prep_nBack_key_resp, 'tStartRefresh')  # time at next scr refresh
        prep_nBack_key_resp.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(prep_nBack_key_resp.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(prep_nBack_key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if prep_nBack_key_resp.status == STARTED and not waitOnFlip:
        theseKeys = prep_nBack_key_resp.getKeys(keyList=['space'], waitRelease=False)
        _prep_nBack_key_resp_allKeys.extend(theseKeys)
        if len(_prep_nBack_key_resp_allKeys):
            prep_nBack_key_resp.keys = _prep_nBack_key_resp_allKeys[-1].name  # just the last key pressed
            prep_nBack_key_resp.rt = _prep_nBack_key_resp_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in prep_nBackComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "prep_nBack"-------
for thisComponent in prep_nBackComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('prep_nBack_text.started', prep_nBack_text.tStartRefresh)
thisExp.addData('prep_nBack_text.stopped', prep_nBack_text.tStopRefresh)
# check responses
if prep_nBack_key_resp.keys in ['', [], None]:  # No response was made
    prep_nBack_key_resp.keys = None
thisExp.addData('prep_nBack_key_resp.keys',prep_nBack_key_resp.keys)
if prep_nBack_key_resp.keys != None:  # we had a response
    thisExp.addData('prep_nBack_key_resp.rt', prep_nBack_key_resp.rt)
thisExp.addData('prep_nBack_key_resp.started', prep_nBack_key_resp.tStartRefresh)
thisExp.addData('prep_nBack_key_resp.stopped', prep_nBack_key_resp.tStopRefresh)
thisExp.nextEntry()
# the Routine "prep_nBack" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
blocks_nBack = data.TrialHandler(nReps=1.0, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('orderA_blocks.xlsx'),
    seed=None, name='blocks_nBack')
thisExp.addLoop(blocks_nBack)  # add the loop to the experiment
thisBlocks_nBack = blocks_nBack.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisBlocks_nBack.rgb)
if thisBlocks_nBack != None:
    for paramName in thisBlocks_nBack:
        exec('{} = thisBlocks_nBack[paramName]'.format(paramName))

for thisBlocks_nBack in blocks_nBack:
    currentLoop = blocks_nBack
    # abbreviate parameter names if possible (e.g. rgb = thisBlocks_nBack.rgb)
    if thisBlocks_nBack != None:
        for paramName in thisBlocks_nBack:
            exec('{} = thisBlocks_nBack[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "target_nBack"-------
    continueRoutine = True
    routineTimer.add(5.000000)
    # update component parameters for each repeat
    # keep track of which components have finished
    target_nBackComponents = [block1_polygon, block1_text1, block1_text2, block1_countdown_3, block1_countdown_2, block1_countdown_1]
    for thisComponent in target_nBackComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    target_nBackClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "target_nBack"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = target_nBackClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=target_nBackClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *block1_polygon* updates
        if block1_polygon.status == NOT_STARTED and tThisFlip >= 2.0-frameTolerance:
            # keep track of start time/frame for later
            block1_polygon.frameNStart = frameN  # exact frame index
            block1_polygon.tStart = t  # local t and not account for scr refresh
            block1_polygon.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(block1_polygon, 'tStartRefresh')  # time at next scr refresh
            block1_polygon.setAutoDraw(True)
        if block1_polygon.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > block1_polygon.tStartRefresh + 3-frameTolerance:
                # keep track of stop time/frame for later
                block1_polygon.tStop = t  # not accounting for scr refresh
                block1_polygon.frameNStop = frameN  # exact frame index
                win.timeOnFlip(block1_polygon, 'tStopRefresh')  # time at next scr refresh
                block1_polygon.setAutoDraw(False)
        
        # *block1_text1* updates
        if block1_text1.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            block1_text1.frameNStart = frameN  # exact frame index
            block1_text1.tStart = t  # local t and not account for scr refresh
            block1_text1.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(block1_text1, 'tStartRefresh')  # time at next scr refresh
            block1_text1.setAutoDraw(True)
        if block1_text1.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > block1_text1.tStartRefresh + 5-frameTolerance:
                # keep track of stop time/frame for later
                block1_text1.tStop = t  # not accounting for scr refresh
                block1_text1.frameNStop = frameN  # exact frame index
                win.timeOnFlip(block1_text1, 'tStopRefresh')  # time at next scr refresh
                block1_text1.setAutoDraw(False)
        
        # *block1_text2* updates
        if block1_text2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            block1_text2.frameNStart = frameN  # exact frame index
            block1_text2.tStart = t  # local t and not account for scr refresh
            block1_text2.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(block1_text2, 'tStartRefresh')  # time at next scr refresh
            block1_text2.setAutoDraw(True)
        if block1_text2.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > block1_text2.tStartRefresh + 5.0-frameTolerance:
                # keep track of stop time/frame for later
                block1_text2.tStop = t  # not accounting for scr refresh
                block1_text2.frameNStop = frameN  # exact frame index
                win.timeOnFlip(block1_text2, 'tStopRefresh')  # time at next scr refresh
                block1_text2.setAutoDraw(False)
        
        # *block1_countdown_3* updates
        if block1_countdown_3.status == NOT_STARTED and tThisFlip >= 2.0-frameTolerance:
            # keep track of start time/frame for later
            block1_countdown_3.frameNStart = frameN  # exact frame index
            block1_countdown_3.tStart = t  # local t and not account for scr refresh
            block1_countdown_3.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(block1_countdown_3, 'tStartRefresh')  # time at next scr refresh
            block1_countdown_3.setAutoDraw(True)
        if block1_countdown_3.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > block1_countdown_3.tStartRefresh + 1.0-frameTolerance:
                # keep track of stop time/frame for later
                block1_countdown_3.tStop = t  # not accounting for scr refresh
                block1_countdown_3.frameNStop = frameN  # exact frame index
                win.timeOnFlip(block1_countdown_3, 'tStopRefresh')  # time at next scr refresh
                block1_countdown_3.setAutoDraw(False)
        
        # *block1_countdown_2* updates
        if block1_countdown_2.status == NOT_STARTED and tThisFlip >= 3.0-frameTolerance:
            # keep track of start time/frame for later
            block1_countdown_2.frameNStart = frameN  # exact frame index
            block1_countdown_2.tStart = t  # local t and not account for scr refresh
            block1_countdown_2.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(block1_countdown_2, 'tStartRefresh')  # time at next scr refresh
            block1_countdown_2.setAutoDraw(True)
        if block1_countdown_2.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > block1_countdown_2.tStartRefresh + 1.0-frameTolerance:
                # keep track of stop time/frame for later
                block1_countdown_2.tStop = t  # not accounting for scr refresh
                block1_countdown_2.frameNStop = frameN  # exact frame index
                win.timeOnFlip(block1_countdown_2, 'tStopRefresh')  # time at next scr refresh
                block1_countdown_2.setAutoDraw(False)
        
        # *block1_countdown_1* updates
        if block1_countdown_1.status == NOT_STARTED and tThisFlip >= 4.0-frameTolerance:
            # keep track of start time/frame for later
            block1_countdown_1.frameNStart = frameN  # exact frame index
            block1_countdown_1.tStart = t  # local t and not account for scr refresh
            block1_countdown_1.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(block1_countdown_1, 'tStartRefresh')  # time at next scr refresh
            block1_countdown_1.setAutoDraw(True)
        if block1_countdown_1.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > block1_countdown_1.tStartRefresh + 1.0-frameTolerance:
                # keep track of stop time/frame for later
                block1_countdown_1.tStop = t  # not accounting for scr refresh
                block1_countdown_1.frameNStop = frameN  # exact frame index
                win.timeOnFlip(block1_countdown_1, 'tStopRefresh')  # time at next scr refresh
                block1_countdown_1.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in target_nBackComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "target_nBack"-------
    for thisComponent in target_nBackComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    blocks_nBack.addData('block1_polygon.started', block1_polygon.tStartRefresh)
    blocks_nBack.addData('block1_polygon.stopped', block1_polygon.tStopRefresh)
    blocks_nBack.addData('block1_text1.started', block1_text1.tStartRefresh)
    blocks_nBack.addData('block1_text1.stopped', block1_text1.tStopRefresh)
    blocks_nBack.addData('block1_text2.started', block1_text2.tStartRefresh)
    blocks_nBack.addData('block1_text2.stopped', block1_text2.tStopRefresh)
    blocks_nBack.addData('block1_countdown_3.started', block1_countdown_3.tStartRefresh)
    blocks_nBack.addData('block1_countdown_3.stopped', block1_countdown_3.tStopRefresh)
    blocks_nBack.addData('block1_countdown_2.started', block1_countdown_2.tStartRefresh)
    blocks_nBack.addData('block1_countdown_2.stopped', block1_countdown_2.tStopRefresh)
    blocks_nBack.addData('block1_countdown_1.started', block1_countdown_1.tStartRefresh)
    blocks_nBack.addData('block1_countdown_1.stopped', block1_countdown_1.tStopRefresh)
    
    # set up handler to look after randomisation of conditions etc
    trials_nBack = data.TrialHandler(nReps=1.0, method='sequential', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions(blockFile),
        seed=None, name='trials_nBack')
    thisExp.addLoop(trials_nBack)  # add the loop to the experiment
    thisTrials_nBack = trials_nBack.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisTrials_nBack.rgb)
    if thisTrials_nBack != None:
        for paramName in thisTrials_nBack:
            exec('{} = thisTrials_nBack[paramName]'.format(paramName))
    
    for thisTrials_nBack in trials_nBack:
        currentLoop = trials_nBack
        # abbreviate parameter names if possible (e.g. rgb = thisTrials_nBack.rgb)
        if thisTrials_nBack != None:
            for paramName in thisTrials_nBack:
                exec('{} = thisTrials_nBack[paramName]'.format(paramName))
        
        # ------Prepare to start Routine "trial_nBack"-------
        continueRoutine = True
        routineTimer.add(1.500000)
        # update component parameters for each repeat
        letter_text.setText(letter)
        response_nBack.keys = []
        response_nBack.rt = []
        _response_nBack_allKeys = []
        # keep track of which components have finished
        trial_nBackComponents = [fixation, letter_text, response_nBack]
        for thisComponent in trial_nBackComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        trial_nBackClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "trial_nBack"-------
        while continueRoutine and routineTimer.getTime() > 0:
            # get current time
            t = trial_nBackClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=trial_nBackClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *fixation* updates
            if fixation.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                fixation.frameNStart = frameN  # exact frame index
                fixation.tStart = t  # local t and not account for scr refresh
                fixation.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(fixation, 'tStartRefresh')  # time at next scr refresh
                fixation.setAutoDraw(True)
            if fixation.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > fixation.tStartRefresh + .4-frameTolerance:
                    # keep track of stop time/frame for later
                    fixation.tStop = t  # not accounting for scr refresh
                    fixation.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(fixation, 'tStopRefresh')  # time at next scr refresh
                    fixation.setAutoDraw(False)
            
            # *letter_text* updates
            if letter_text.status == NOT_STARTED and tThisFlip >= .4-frameTolerance:
                # keep track of start time/frame for later
                letter_text.frameNStart = frameN  # exact frame index
                letter_text.tStart = t  # local t and not account for scr refresh
                letter_text.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(letter_text, 'tStartRefresh')  # time at next scr refresh
                letter_text.setAutoDraw(True)
            if letter_text.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > letter_text.tStartRefresh + 1.1-frameTolerance:
                    # keep track of stop time/frame for later
                    letter_text.tStop = t  # not accounting for scr refresh
                    letter_text.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(letter_text, 'tStopRefresh')  # time at next scr refresh
                    letter_text.setAutoDraw(False)
            
            # *response_nBack* updates
            waitOnFlip = False
            if response_nBack.status == NOT_STARTED and tThisFlip >= 0.4-frameTolerance:
                # keep track of start time/frame for later
                response_nBack.frameNStart = frameN  # exact frame index
                response_nBack.tStart = t  # local t and not account for scr refresh
                response_nBack.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(response_nBack, 'tStartRefresh')  # time at next scr refresh
                response_nBack.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(response_nBack.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(response_nBack.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if response_nBack.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > response_nBack.tStartRefresh + 1.1-frameTolerance:
                    # keep track of stop time/frame for later
                    response_nBack.tStop = t  # not accounting for scr refresh
                    response_nBack.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(response_nBack, 'tStopRefresh')  # time at next scr refresh
                    response_nBack.status = FINISHED
            if response_nBack.status == STARTED and not waitOnFlip:
                theseKeys = response_nBack.getKeys(keyList=['left','right'], waitRelease=False)
                _response_nBack_allKeys.extend(theseKeys)
                if len(_response_nBack_allKeys):
                    response_nBack.keys = _response_nBack_allKeys[-1].name  # just the last key pressed
                    response_nBack.rt = _response_nBack_allKeys[-1].rt
                    # was this correct?
                    if (response_nBack.keys == str(corrAns)) or (response_nBack.keys == corrAns):
                        response_nBack.corr = 1
                    else:
                        response_nBack.corr = 0
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in trial_nBackComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "trial_nBack"-------
        for thisComponent in trial_nBackComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials_nBack.addData('fixation.started', fixation.tStartRefresh)
        trials_nBack.addData('fixation.stopped', fixation.tStopRefresh)
        trials_nBack.addData('letter_text.started', letter_text.tStartRefresh)
        trials_nBack.addData('letter_text.stopped', letter_text.tStopRefresh)
        # check responses
        if response_nBack.keys in ['', [], None]:  # No response was made
            response_nBack.keys = None
            # was no response the correct answer?!
            if str(corrAns).lower() == 'none':
               response_nBack.corr = 1;  # correct non-response
            else:
               response_nBack.corr = 0;  # failed to respond (incorrectly)
        # store data for trials_nBack (TrialHandler)
        trials_nBack.addData('response_nBack.keys',response_nBack.keys)
        trials_nBack.addData('response_nBack.corr', response_nBack.corr)
        if response_nBack.keys != None:  # we had a response
            trials_nBack.addData('response_nBack.rt', response_nBack.rt)
        trials_nBack.addData('response_nBack.started', response_nBack.tStartRefresh)
        trials_nBack.addData('response_nBack.stopped', response_nBack.tStopRefresh)
        thisExp.nextEntry()
        
    # completed 1.0 repeats of 'trials_nBack'
    
    # get names of stimulus parameters
    if trials_nBack.trialList in ([], [None], None):
        params = []
    else:
        params = trials_nBack.trialList[0].keys()
    # save data for this loop
    trials_nBack.saveAsExcel(filename + '.xlsx', sheetName='trials_nBack',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
    trials_nBack.saveAsText(filename + 'trials_nBack.csv', delim=',',
        stimOut=params,
        dataOut=['n','all_mean','all_std', 'all_raw'])
# completed 1.0 repeats of 'blocks_nBack'


# ------Prepare to start Routine "target_block2"-------
continueRoutine = True
routineTimer.add(5.000000)
# update component parameters for each repeat
# keep track of which components have finished
target_block2Components = [block2_polygon, block2_text1, block2_text2, block1_countdown, block1_countdown_4, block1_countdown_5]
for thisComponent in target_block2Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
target_block2Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "target_block2"-------
while continueRoutine and routineTimer.getTime() > 0:
    # get current time
    t = target_block2Clock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=target_block2Clock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *block2_polygon* updates
    if block2_polygon.status == NOT_STARTED and tThisFlip >= 2.0-frameTolerance:
        # keep track of start time/frame for later
        block2_polygon.frameNStart = frameN  # exact frame index
        block2_polygon.tStart = t  # local t and not account for scr refresh
        block2_polygon.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block2_polygon, 'tStartRefresh')  # time at next scr refresh
        block2_polygon.setAutoDraw(True)
    if block2_polygon.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block2_polygon.tStartRefresh + 3-frameTolerance:
            # keep track of stop time/frame for later
            block2_polygon.tStop = t  # not accounting for scr refresh
            block2_polygon.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block2_polygon, 'tStopRefresh')  # time at next scr refresh
            block2_polygon.setAutoDraw(False)
    
    # *block2_text1* updates
    if block2_text1.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        block2_text1.frameNStart = frameN  # exact frame index
        block2_text1.tStart = t  # local t and not account for scr refresh
        block2_text1.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block2_text1, 'tStartRefresh')  # time at next scr refresh
        block2_text1.setAutoDraw(True)
    if block2_text1.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block2_text1.tStartRefresh + 5-frameTolerance:
            # keep track of stop time/frame for later
            block2_text1.tStop = t  # not accounting for scr refresh
            block2_text1.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block2_text1, 'tStopRefresh')  # time at next scr refresh
            block2_text1.setAutoDraw(False)
    
    # *block2_text2* updates
    if block2_text2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        block2_text2.frameNStart = frameN  # exact frame index
        block2_text2.tStart = t  # local t and not account for scr refresh
        block2_text2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block2_text2, 'tStartRefresh')  # time at next scr refresh
        block2_text2.setAutoDraw(True)
    if block2_text2.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block2_text2.tStartRefresh + 5.0-frameTolerance:
            # keep track of stop time/frame for later
            block2_text2.tStop = t  # not accounting for scr refresh
            block2_text2.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block2_text2, 'tStopRefresh')  # time at next scr refresh
            block2_text2.setAutoDraw(False)
    
    # *block1_countdown* updates
    if block1_countdown.status == NOT_STARTED and tThisFlip >= 2.0-frameTolerance:
        # keep track of start time/frame for later
        block1_countdown.frameNStart = frameN  # exact frame index
        block1_countdown.tStart = t  # local t and not account for scr refresh
        block1_countdown.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block1_countdown, 'tStartRefresh')  # time at next scr refresh
        block1_countdown.setAutoDraw(True)
    if block1_countdown.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block1_countdown.tStartRefresh + 1.0-frameTolerance:
            # keep track of stop time/frame for later
            block1_countdown.tStop = t  # not accounting for scr refresh
            block1_countdown.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block1_countdown, 'tStopRefresh')  # time at next scr refresh
            block1_countdown.setAutoDraw(False)
    
    # *block1_countdown_4* updates
    if block1_countdown_4.status == NOT_STARTED and tThisFlip >= 3.0-frameTolerance:
        # keep track of start time/frame for later
        block1_countdown_4.frameNStart = frameN  # exact frame index
        block1_countdown_4.tStart = t  # local t and not account for scr refresh
        block1_countdown_4.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block1_countdown_4, 'tStartRefresh')  # time at next scr refresh
        block1_countdown_4.setAutoDraw(True)
    if block1_countdown_4.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block1_countdown_4.tStartRefresh + 1.0-frameTolerance:
            # keep track of stop time/frame for later
            block1_countdown_4.tStop = t  # not accounting for scr refresh
            block1_countdown_4.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block1_countdown_4, 'tStopRefresh')  # time at next scr refresh
            block1_countdown_4.setAutoDraw(False)
    
    # *block1_countdown_5* updates
    if block1_countdown_5.status == NOT_STARTED and tThisFlip >= 4.0-frameTolerance:
        # keep track of start time/frame for later
        block1_countdown_5.frameNStart = frameN  # exact frame index
        block1_countdown_5.tStart = t  # local t and not account for scr refresh
        block1_countdown_5.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block1_countdown_5, 'tStartRefresh')  # time at next scr refresh
        block1_countdown_5.setAutoDraw(True)
    if block1_countdown_5.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block1_countdown_5.tStartRefresh + 1.0-frameTolerance:
            # keep track of stop time/frame for later
            block1_countdown_5.tStop = t  # not accounting for scr refresh
            block1_countdown_5.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block1_countdown_5, 'tStopRefresh')  # time at next scr refresh
            block1_countdown_5.setAutoDraw(False)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in target_block2Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "target_block2"-------
for thisComponent in target_block2Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('block2_polygon.started', block2_polygon.tStartRefresh)
thisExp.addData('block2_polygon.stopped', block2_polygon.tStopRefresh)
thisExp.addData('block2_text1.started', block2_text1.tStartRefresh)
thisExp.addData('block2_text1.stopped', block2_text1.tStopRefresh)
thisExp.addData('block2_text2.started', block2_text2.tStartRefresh)
thisExp.addData('block2_text2.stopped', block2_text2.tStopRefresh)
thisExp.addData('block1_countdown.started', block1_countdown.tStartRefresh)
thisExp.addData('block1_countdown.stopped', block1_countdown.tStopRefresh)
thisExp.addData('block1_countdown_4.started', block1_countdown_4.tStartRefresh)
thisExp.addData('block1_countdown_4.stopped', block1_countdown_4.tStopRefresh)
thisExp.addData('block1_countdown_5.started', block1_countdown_5.tStartRefresh)
thisExp.addData('block1_countdown_5.stopped', block1_countdown_5.tStopRefresh)

# set up handler to look after randomisation of conditions etc
loop_nBack_block2 = data.TrialHandler(nReps=1.0, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('orderA_0back_block2.csv'),
    seed=None, name='loop_nBack_block2')
thisExp.addLoop(loop_nBack_block2)  # add the loop to the experiment
thisLoop_nBack_block2 = loop_nBack_block2.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisLoop_nBack_block2.rgb)
if thisLoop_nBack_block2 != None:
    for paramName in thisLoop_nBack_block2:
        exec('{} = thisLoop_nBack_block2[paramName]'.format(paramName))

for thisLoop_nBack_block2 in loop_nBack_block2:
    currentLoop = loop_nBack_block2
    # abbreviate parameter names if possible (e.g. rgb = thisLoop_nBack_block2.rgb)
    if thisLoop_nBack_block2 != None:
        for paramName in thisLoop_nBack_block2:
            exec('{} = thisLoop_nBack_block2[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "trial_nBack"-------
    continueRoutine = True
    routineTimer.add(1.500000)
    # update component parameters for each repeat
    letter_text.setText(letter)
    response_nBack.keys = []
    response_nBack.rt = []
    _response_nBack_allKeys = []
    # keep track of which components have finished
    trial_nBackComponents = [fixation, letter_text, response_nBack]
    for thisComponent in trial_nBackComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    trial_nBackClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "trial_nBack"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = trial_nBackClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=trial_nBackClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *fixation* updates
        if fixation.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            fixation.frameNStart = frameN  # exact frame index
            fixation.tStart = t  # local t and not account for scr refresh
            fixation.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(fixation, 'tStartRefresh')  # time at next scr refresh
            fixation.setAutoDraw(True)
        if fixation.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > fixation.tStartRefresh + .4-frameTolerance:
                # keep track of stop time/frame for later
                fixation.tStop = t  # not accounting for scr refresh
                fixation.frameNStop = frameN  # exact frame index
                win.timeOnFlip(fixation, 'tStopRefresh')  # time at next scr refresh
                fixation.setAutoDraw(False)
        
        # *letter_text* updates
        if letter_text.status == NOT_STARTED and tThisFlip >= .4-frameTolerance:
            # keep track of start time/frame for later
            letter_text.frameNStart = frameN  # exact frame index
            letter_text.tStart = t  # local t and not account for scr refresh
            letter_text.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(letter_text, 'tStartRefresh')  # time at next scr refresh
            letter_text.setAutoDraw(True)
        if letter_text.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > letter_text.tStartRefresh + 1.1-frameTolerance:
                # keep track of stop time/frame for later
                letter_text.tStop = t  # not accounting for scr refresh
                letter_text.frameNStop = frameN  # exact frame index
                win.timeOnFlip(letter_text, 'tStopRefresh')  # time at next scr refresh
                letter_text.setAutoDraw(False)
        
        # *response_nBack* updates
        waitOnFlip = False
        if response_nBack.status == NOT_STARTED and tThisFlip >= 0.4-frameTolerance:
            # keep track of start time/frame for later
            response_nBack.frameNStart = frameN  # exact frame index
            response_nBack.tStart = t  # local t and not account for scr refresh
            response_nBack.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(response_nBack, 'tStartRefresh')  # time at next scr refresh
            response_nBack.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(response_nBack.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(response_nBack.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if response_nBack.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > response_nBack.tStartRefresh + 1.1-frameTolerance:
                # keep track of stop time/frame for later
                response_nBack.tStop = t  # not accounting for scr refresh
                response_nBack.frameNStop = frameN  # exact frame index
                win.timeOnFlip(response_nBack, 'tStopRefresh')  # time at next scr refresh
                response_nBack.status = FINISHED
        if response_nBack.status == STARTED and not waitOnFlip:
            theseKeys = response_nBack.getKeys(keyList=['left','right'], waitRelease=False)
            _response_nBack_allKeys.extend(theseKeys)
            if len(_response_nBack_allKeys):
                response_nBack.keys = _response_nBack_allKeys[-1].name  # just the last key pressed
                response_nBack.rt = _response_nBack_allKeys[-1].rt
                # was this correct?
                if (response_nBack.keys == str(corrAns)) or (response_nBack.keys == corrAns):
                    response_nBack.corr = 1
                else:
                    response_nBack.corr = 0
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in trial_nBackComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "trial_nBack"-------
    for thisComponent in trial_nBackComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    loop_nBack_block2.addData('fixation.started', fixation.tStartRefresh)
    loop_nBack_block2.addData('fixation.stopped', fixation.tStopRefresh)
    loop_nBack_block2.addData('letter_text.started', letter_text.tStartRefresh)
    loop_nBack_block2.addData('letter_text.stopped', letter_text.tStopRefresh)
    # check responses
    if response_nBack.keys in ['', [], None]:  # No response was made
        response_nBack.keys = None
        # was no response the correct answer?!
        if str(corrAns).lower() == 'none':
           response_nBack.corr = 1;  # correct non-response
        else:
           response_nBack.corr = 0;  # failed to respond (incorrectly)
    # store data for loop_nBack_block2 (TrialHandler)
    loop_nBack_block2.addData('response_nBack.keys',response_nBack.keys)
    loop_nBack_block2.addData('response_nBack.corr', response_nBack.corr)
    if response_nBack.keys != None:  # we had a response
        loop_nBack_block2.addData('response_nBack.rt', response_nBack.rt)
    loop_nBack_block2.addData('response_nBack.started', response_nBack.tStartRefresh)
    loop_nBack_block2.addData('response_nBack.stopped', response_nBack.tStopRefresh)
    thisExp.nextEntry()
    
# completed 1.0 repeats of 'loop_nBack_block2'

# get names of stimulus parameters
if loop_nBack_block2.trialList in ([], [None], None):
    params = []
else:
    params = loop_nBack_block2.trialList[0].keys()
# save data for this loop
loop_nBack_block2.saveAsExcel(filename + '.xlsx', sheetName='loop_nBack_block2',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])
loop_nBack_block2.saveAsText(filename + 'loop_nBack_block2.csv', delim=',',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])

# ------Prepare to start Routine "target_block3"-------
continueRoutine = True
routineTimer.add(5.000000)
# update component parameters for each repeat
# keep track of which components have finished
target_block3Components = [block3_polygon, block3_text1, block3_text2, block3_countdown_3, block3_countdown_2, block3_countdown_1]
for thisComponent in target_block3Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
target_block3Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "target_block3"-------
while continueRoutine and routineTimer.getTime() > 0:
    # get current time
    t = target_block3Clock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=target_block3Clock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *block3_polygon* updates
    if block3_polygon.status == NOT_STARTED and tThisFlip >= 2.0-frameTolerance:
        # keep track of start time/frame for later
        block3_polygon.frameNStart = frameN  # exact frame index
        block3_polygon.tStart = t  # local t and not account for scr refresh
        block3_polygon.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block3_polygon, 'tStartRefresh')  # time at next scr refresh
        block3_polygon.setAutoDraw(True)
    if block3_polygon.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block3_polygon.tStartRefresh + 3-frameTolerance:
            # keep track of stop time/frame for later
            block3_polygon.tStop = t  # not accounting for scr refresh
            block3_polygon.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block3_polygon, 'tStopRefresh')  # time at next scr refresh
            block3_polygon.setAutoDraw(False)
    
    # *block3_text1* updates
    if block3_text1.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        block3_text1.frameNStart = frameN  # exact frame index
        block3_text1.tStart = t  # local t and not account for scr refresh
        block3_text1.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block3_text1, 'tStartRefresh')  # time at next scr refresh
        block3_text1.setAutoDraw(True)
    if block3_text1.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block3_text1.tStartRefresh + 5-frameTolerance:
            # keep track of stop time/frame for later
            block3_text1.tStop = t  # not accounting for scr refresh
            block3_text1.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block3_text1, 'tStopRefresh')  # time at next scr refresh
            block3_text1.setAutoDraw(False)
    
    # *block3_text2* updates
    if block3_text2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        block3_text2.frameNStart = frameN  # exact frame index
        block3_text2.tStart = t  # local t and not account for scr refresh
        block3_text2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block3_text2, 'tStartRefresh')  # time at next scr refresh
        block3_text2.setAutoDraw(True)
    if block3_text2.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block3_text2.tStartRefresh + 5.0-frameTolerance:
            # keep track of stop time/frame for later
            block3_text2.tStop = t  # not accounting for scr refresh
            block3_text2.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block3_text2, 'tStopRefresh')  # time at next scr refresh
            block3_text2.setAutoDraw(False)
    
    # *block3_countdown_3* updates
    if block3_countdown_3.status == NOT_STARTED and tThisFlip >= 2.0-frameTolerance:
        # keep track of start time/frame for later
        block3_countdown_3.frameNStart = frameN  # exact frame index
        block3_countdown_3.tStart = t  # local t and not account for scr refresh
        block3_countdown_3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block3_countdown_3, 'tStartRefresh')  # time at next scr refresh
        block3_countdown_3.setAutoDraw(True)
    if block3_countdown_3.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block3_countdown_3.tStartRefresh + 1.0-frameTolerance:
            # keep track of stop time/frame for later
            block3_countdown_3.tStop = t  # not accounting for scr refresh
            block3_countdown_3.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block3_countdown_3, 'tStopRefresh')  # time at next scr refresh
            block3_countdown_3.setAutoDraw(False)
    
    # *block3_countdown_2* updates
    if block3_countdown_2.status == NOT_STARTED and tThisFlip >= 3.0-frameTolerance:
        # keep track of start time/frame for later
        block3_countdown_2.frameNStart = frameN  # exact frame index
        block3_countdown_2.tStart = t  # local t and not account for scr refresh
        block3_countdown_2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block3_countdown_2, 'tStartRefresh')  # time at next scr refresh
        block3_countdown_2.setAutoDraw(True)
    if block3_countdown_2.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block3_countdown_2.tStartRefresh + 1.0-frameTolerance:
            # keep track of stop time/frame for later
            block3_countdown_2.tStop = t  # not accounting for scr refresh
            block3_countdown_2.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block3_countdown_2, 'tStopRefresh')  # time at next scr refresh
            block3_countdown_2.setAutoDraw(False)
    
    # *block3_countdown_1* updates
    if block3_countdown_1.status == NOT_STARTED and tThisFlip >= 4.0-frameTolerance:
        # keep track of start time/frame for later
        block3_countdown_1.frameNStart = frameN  # exact frame index
        block3_countdown_1.tStart = t  # local t and not account for scr refresh
        block3_countdown_1.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block3_countdown_1, 'tStartRefresh')  # time at next scr refresh
        block3_countdown_1.setAutoDraw(True)
    if block3_countdown_1.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block3_countdown_1.tStartRefresh + 1.0-frameTolerance:
            # keep track of stop time/frame for later
            block3_countdown_1.tStop = t  # not accounting for scr refresh
            block3_countdown_1.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block3_countdown_1, 'tStopRefresh')  # time at next scr refresh
            block3_countdown_1.setAutoDraw(False)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in target_block3Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "target_block3"-------
for thisComponent in target_block3Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('block3_polygon.started', block3_polygon.tStartRefresh)
thisExp.addData('block3_polygon.stopped', block3_polygon.tStopRefresh)
thisExp.addData('block3_text1.started', block3_text1.tStartRefresh)
thisExp.addData('block3_text1.stopped', block3_text1.tStopRefresh)
thisExp.addData('block3_text2.started', block3_text2.tStartRefresh)
thisExp.addData('block3_text2.stopped', block3_text2.tStopRefresh)
thisExp.addData('block3_countdown_3.started', block3_countdown_3.tStartRefresh)
thisExp.addData('block3_countdown_3.stopped', block3_countdown_3.tStopRefresh)
thisExp.addData('block3_countdown_2.started', block3_countdown_2.tStartRefresh)
thisExp.addData('block3_countdown_2.stopped', block3_countdown_2.tStopRefresh)
thisExp.addData('block3_countdown_1.started', block3_countdown_1.tStartRefresh)
thisExp.addData('block3_countdown_1.stopped', block3_countdown_1.tStopRefresh)

# set up handler to look after randomisation of conditions etc
loop_nBack_b3 = data.TrialHandler(nReps=1.0, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('orderA_0back_block3.csv'),
    seed=None, name='loop_nBack_b3')
thisExp.addLoop(loop_nBack_b3)  # add the loop to the experiment
thisLoop_nBack_b3 = loop_nBack_b3.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisLoop_nBack_b3.rgb)
if thisLoop_nBack_b3 != None:
    for paramName in thisLoop_nBack_b3:
        exec('{} = thisLoop_nBack_b3[paramName]'.format(paramName))

for thisLoop_nBack_b3 in loop_nBack_b3:
    currentLoop = loop_nBack_b3
    # abbreviate parameter names if possible (e.g. rgb = thisLoop_nBack_b3.rgb)
    if thisLoop_nBack_b3 != None:
        for paramName in thisLoop_nBack_b3:
            exec('{} = thisLoop_nBack_b3[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "trial_nBack"-------
    continueRoutine = True
    routineTimer.add(1.500000)
    # update component parameters for each repeat
    letter_text.setText(letter)
    response_nBack.keys = []
    response_nBack.rt = []
    _response_nBack_allKeys = []
    # keep track of which components have finished
    trial_nBackComponents = [fixation, letter_text, response_nBack]
    for thisComponent in trial_nBackComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    trial_nBackClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "trial_nBack"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = trial_nBackClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=trial_nBackClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *fixation* updates
        if fixation.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            fixation.frameNStart = frameN  # exact frame index
            fixation.tStart = t  # local t and not account for scr refresh
            fixation.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(fixation, 'tStartRefresh')  # time at next scr refresh
            fixation.setAutoDraw(True)
        if fixation.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > fixation.tStartRefresh + .4-frameTolerance:
                # keep track of stop time/frame for later
                fixation.tStop = t  # not accounting for scr refresh
                fixation.frameNStop = frameN  # exact frame index
                win.timeOnFlip(fixation, 'tStopRefresh')  # time at next scr refresh
                fixation.setAutoDraw(False)
        
        # *letter_text* updates
        if letter_text.status == NOT_STARTED and tThisFlip >= .4-frameTolerance:
            # keep track of start time/frame for later
            letter_text.frameNStart = frameN  # exact frame index
            letter_text.tStart = t  # local t and not account for scr refresh
            letter_text.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(letter_text, 'tStartRefresh')  # time at next scr refresh
            letter_text.setAutoDraw(True)
        if letter_text.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > letter_text.tStartRefresh + 1.1-frameTolerance:
                # keep track of stop time/frame for later
                letter_text.tStop = t  # not accounting for scr refresh
                letter_text.frameNStop = frameN  # exact frame index
                win.timeOnFlip(letter_text, 'tStopRefresh')  # time at next scr refresh
                letter_text.setAutoDraw(False)
        
        # *response_nBack* updates
        waitOnFlip = False
        if response_nBack.status == NOT_STARTED and tThisFlip >= 0.4-frameTolerance:
            # keep track of start time/frame for later
            response_nBack.frameNStart = frameN  # exact frame index
            response_nBack.tStart = t  # local t and not account for scr refresh
            response_nBack.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(response_nBack, 'tStartRefresh')  # time at next scr refresh
            response_nBack.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(response_nBack.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(response_nBack.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if response_nBack.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > response_nBack.tStartRefresh + 1.1-frameTolerance:
                # keep track of stop time/frame for later
                response_nBack.tStop = t  # not accounting for scr refresh
                response_nBack.frameNStop = frameN  # exact frame index
                win.timeOnFlip(response_nBack, 'tStopRefresh')  # time at next scr refresh
                response_nBack.status = FINISHED
        if response_nBack.status == STARTED and not waitOnFlip:
            theseKeys = response_nBack.getKeys(keyList=['left','right'], waitRelease=False)
            _response_nBack_allKeys.extend(theseKeys)
            if len(_response_nBack_allKeys):
                response_nBack.keys = _response_nBack_allKeys[-1].name  # just the last key pressed
                response_nBack.rt = _response_nBack_allKeys[-1].rt
                # was this correct?
                if (response_nBack.keys == str(corrAns)) or (response_nBack.keys == corrAns):
                    response_nBack.corr = 1
                else:
                    response_nBack.corr = 0
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in trial_nBackComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "trial_nBack"-------
    for thisComponent in trial_nBackComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    loop_nBack_b3.addData('fixation.started', fixation.tStartRefresh)
    loop_nBack_b3.addData('fixation.stopped', fixation.tStopRefresh)
    loop_nBack_b3.addData('letter_text.started', letter_text.tStartRefresh)
    loop_nBack_b3.addData('letter_text.stopped', letter_text.tStopRefresh)
    # check responses
    if response_nBack.keys in ['', [], None]:  # No response was made
        response_nBack.keys = None
        # was no response the correct answer?!
        if str(corrAns).lower() == 'none':
           response_nBack.corr = 1;  # correct non-response
        else:
           response_nBack.corr = 0;  # failed to respond (incorrectly)
    # store data for loop_nBack_b3 (TrialHandler)
    loop_nBack_b3.addData('response_nBack.keys',response_nBack.keys)
    loop_nBack_b3.addData('response_nBack.corr', response_nBack.corr)
    if response_nBack.keys != None:  # we had a response
        loop_nBack_b3.addData('response_nBack.rt', response_nBack.rt)
    loop_nBack_b3.addData('response_nBack.started', response_nBack.tStartRefresh)
    loop_nBack_b3.addData('response_nBack.stopped', response_nBack.tStopRefresh)
    thisExp.nextEntry()
    
# completed 1.0 repeats of 'loop_nBack_b3'

# get names of stimulus parameters
if loop_nBack_b3.trialList in ([], [None], None):
    params = []
else:
    params = loop_nBack_b3.trialList[0].keys()
# save data for this loop
loop_nBack_b3.saveAsExcel(filename + '.xlsx', sheetName='loop_nBack_b3',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])
loop_nBack_b3.saveAsText(filename + 'loop_nBack_b3.csv', delim=',',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])

# ------Prepare to start Routine "target_block4"-------
continueRoutine = True
routineTimer.add(5.000000)
# update component parameters for each repeat
# keep track of which components have finished
target_block4Components = [block4_polygon, block4_text1, block4_text2, block4_countdown_3, block4_countdown_2, block4_countdown_1]
for thisComponent in target_block4Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
target_block4Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "target_block4"-------
while continueRoutine and routineTimer.getTime() > 0:
    # get current time
    t = target_block4Clock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=target_block4Clock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *block4_polygon* updates
    if block4_polygon.status == NOT_STARTED and tThisFlip >= 2.0-frameTolerance:
        # keep track of start time/frame for later
        block4_polygon.frameNStart = frameN  # exact frame index
        block4_polygon.tStart = t  # local t and not account for scr refresh
        block4_polygon.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block4_polygon, 'tStartRefresh')  # time at next scr refresh
        block4_polygon.setAutoDraw(True)
    if block4_polygon.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block4_polygon.tStartRefresh + 3-frameTolerance:
            # keep track of stop time/frame for later
            block4_polygon.tStop = t  # not accounting for scr refresh
            block4_polygon.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block4_polygon, 'tStopRefresh')  # time at next scr refresh
            block4_polygon.setAutoDraw(False)
    
    # *block4_text1* updates
    if block4_text1.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        block4_text1.frameNStart = frameN  # exact frame index
        block4_text1.tStart = t  # local t and not account for scr refresh
        block4_text1.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block4_text1, 'tStartRefresh')  # time at next scr refresh
        block4_text1.setAutoDraw(True)
    if block4_text1.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block4_text1.tStartRefresh + 5-frameTolerance:
            # keep track of stop time/frame for later
            block4_text1.tStop = t  # not accounting for scr refresh
            block4_text1.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block4_text1, 'tStopRefresh')  # time at next scr refresh
            block4_text1.setAutoDraw(False)
    
    # *block4_text2* updates
    if block4_text2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        block4_text2.frameNStart = frameN  # exact frame index
        block4_text2.tStart = t  # local t and not account for scr refresh
        block4_text2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block4_text2, 'tStartRefresh')  # time at next scr refresh
        block4_text2.setAutoDraw(True)
    if block4_text2.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block4_text2.tStartRefresh + 5.0-frameTolerance:
            # keep track of stop time/frame for later
            block4_text2.tStop = t  # not accounting for scr refresh
            block4_text2.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block4_text2, 'tStopRefresh')  # time at next scr refresh
            block4_text2.setAutoDraw(False)
    
    # *block4_countdown_3* updates
    if block4_countdown_3.status == NOT_STARTED and tThisFlip >= 2.0-frameTolerance:
        # keep track of start time/frame for later
        block4_countdown_3.frameNStart = frameN  # exact frame index
        block4_countdown_3.tStart = t  # local t and not account for scr refresh
        block4_countdown_3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block4_countdown_3, 'tStartRefresh')  # time at next scr refresh
        block4_countdown_3.setAutoDraw(True)
    if block4_countdown_3.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block4_countdown_3.tStartRefresh + 1.0-frameTolerance:
            # keep track of stop time/frame for later
            block4_countdown_3.tStop = t  # not accounting for scr refresh
            block4_countdown_3.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block4_countdown_3, 'tStopRefresh')  # time at next scr refresh
            block4_countdown_3.setAutoDraw(False)
    
    # *block4_countdown_2* updates
    if block4_countdown_2.status == NOT_STARTED and tThisFlip >= 3.0-frameTolerance:
        # keep track of start time/frame for later
        block4_countdown_2.frameNStart = frameN  # exact frame index
        block4_countdown_2.tStart = t  # local t and not account for scr refresh
        block4_countdown_2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block4_countdown_2, 'tStartRefresh')  # time at next scr refresh
        block4_countdown_2.setAutoDraw(True)
    if block4_countdown_2.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block4_countdown_2.tStartRefresh + 1.0-frameTolerance:
            # keep track of stop time/frame for later
            block4_countdown_2.tStop = t  # not accounting for scr refresh
            block4_countdown_2.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block4_countdown_2, 'tStopRefresh')  # time at next scr refresh
            block4_countdown_2.setAutoDraw(False)
    
    # *block4_countdown_1* updates
    if block4_countdown_1.status == NOT_STARTED and tThisFlip >= 4.0-frameTolerance:
        # keep track of start time/frame for later
        block4_countdown_1.frameNStart = frameN  # exact frame index
        block4_countdown_1.tStart = t  # local t and not account for scr refresh
        block4_countdown_1.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(block4_countdown_1, 'tStartRefresh')  # time at next scr refresh
        block4_countdown_1.setAutoDraw(True)
    if block4_countdown_1.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > block4_countdown_1.tStartRefresh + 1.0-frameTolerance:
            # keep track of stop time/frame for later
            block4_countdown_1.tStop = t  # not accounting for scr refresh
            block4_countdown_1.frameNStop = frameN  # exact frame index
            win.timeOnFlip(block4_countdown_1, 'tStopRefresh')  # time at next scr refresh
            block4_countdown_1.setAutoDraw(False)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in target_block4Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "target_block4"-------
for thisComponent in target_block4Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('block4_polygon.started', block4_polygon.tStartRefresh)
thisExp.addData('block4_polygon.stopped', block4_polygon.tStopRefresh)
thisExp.addData('block4_text1.started', block4_text1.tStartRefresh)
thisExp.addData('block4_text1.stopped', block4_text1.tStopRefresh)
thisExp.addData('block4_text2.started', block4_text2.tStartRefresh)
thisExp.addData('block4_text2.stopped', block4_text2.tStopRefresh)
thisExp.addData('block4_countdown_3.started', block4_countdown_3.tStartRefresh)
thisExp.addData('block4_countdown_3.stopped', block4_countdown_3.tStopRefresh)
thisExp.addData('block4_countdown_2.started', block4_countdown_2.tStartRefresh)
thisExp.addData('block4_countdown_2.stopped', block4_countdown_2.tStopRefresh)
thisExp.addData('block4_countdown_1.started', block4_countdown_1.tStartRefresh)
thisExp.addData('block4_countdown_1.stopped', block4_countdown_1.tStopRefresh)

# set up handler to look after randomisation of conditions etc
loop_nBack_block4 = data.TrialHandler(nReps=1.0, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('orderA_0back_block4.csv'),
    seed=None, name='loop_nBack_block4')
thisExp.addLoop(loop_nBack_block4)  # add the loop to the experiment
thisLoop_nBack_block4 = loop_nBack_block4.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisLoop_nBack_block4.rgb)
if thisLoop_nBack_block4 != None:
    for paramName in thisLoop_nBack_block4:
        exec('{} = thisLoop_nBack_block4[paramName]'.format(paramName))

for thisLoop_nBack_block4 in loop_nBack_block4:
    currentLoop = loop_nBack_block4
    # abbreviate parameter names if possible (e.g. rgb = thisLoop_nBack_block4.rgb)
    if thisLoop_nBack_block4 != None:
        for paramName in thisLoop_nBack_block4:
            exec('{} = thisLoop_nBack_block4[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "trial_nBack"-------
    continueRoutine = True
    routineTimer.add(1.500000)
    # update component parameters for each repeat
    letter_text.setText(letter)
    response_nBack.keys = []
    response_nBack.rt = []
    _response_nBack_allKeys = []
    # keep track of which components have finished
    trial_nBackComponents = [fixation, letter_text, response_nBack]
    for thisComponent in trial_nBackComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    trial_nBackClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "trial_nBack"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = trial_nBackClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=trial_nBackClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *fixation* updates
        if fixation.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            fixation.frameNStart = frameN  # exact frame index
            fixation.tStart = t  # local t and not account for scr refresh
            fixation.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(fixation, 'tStartRefresh')  # time at next scr refresh
            fixation.setAutoDraw(True)
        if fixation.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > fixation.tStartRefresh + .4-frameTolerance:
                # keep track of stop time/frame for later
                fixation.tStop = t  # not accounting for scr refresh
                fixation.frameNStop = frameN  # exact frame index
                win.timeOnFlip(fixation, 'tStopRefresh')  # time at next scr refresh
                fixation.setAutoDraw(False)
        
        # *letter_text* updates
        if letter_text.status == NOT_STARTED and tThisFlip >= .4-frameTolerance:
            # keep track of start time/frame for later
            letter_text.frameNStart = frameN  # exact frame index
            letter_text.tStart = t  # local t and not account for scr refresh
            letter_text.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(letter_text, 'tStartRefresh')  # time at next scr refresh
            letter_text.setAutoDraw(True)
        if letter_text.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > letter_text.tStartRefresh + 1.1-frameTolerance:
                # keep track of stop time/frame for later
                letter_text.tStop = t  # not accounting for scr refresh
                letter_text.frameNStop = frameN  # exact frame index
                win.timeOnFlip(letter_text, 'tStopRefresh')  # time at next scr refresh
                letter_text.setAutoDraw(False)
        
        # *response_nBack* updates
        waitOnFlip = False
        if response_nBack.status == NOT_STARTED and tThisFlip >= 0.4-frameTolerance:
            # keep track of start time/frame for later
            response_nBack.frameNStart = frameN  # exact frame index
            response_nBack.tStart = t  # local t and not account for scr refresh
            response_nBack.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(response_nBack, 'tStartRefresh')  # time at next scr refresh
            response_nBack.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(response_nBack.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(response_nBack.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if response_nBack.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > response_nBack.tStartRefresh + 1.1-frameTolerance:
                # keep track of stop time/frame for later
                response_nBack.tStop = t  # not accounting for scr refresh
                response_nBack.frameNStop = frameN  # exact frame index
                win.timeOnFlip(response_nBack, 'tStopRefresh')  # time at next scr refresh
                response_nBack.status = FINISHED
        if response_nBack.status == STARTED and not waitOnFlip:
            theseKeys = response_nBack.getKeys(keyList=['left','right'], waitRelease=False)
            _response_nBack_allKeys.extend(theseKeys)
            if len(_response_nBack_allKeys):
                response_nBack.keys = _response_nBack_allKeys[-1].name  # just the last key pressed
                response_nBack.rt = _response_nBack_allKeys[-1].rt
                # was this correct?
                if (response_nBack.keys == str(corrAns)) or (response_nBack.keys == corrAns):
                    response_nBack.corr = 1
                else:
                    response_nBack.corr = 0
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in trial_nBackComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "trial_nBack"-------
    for thisComponent in trial_nBackComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    loop_nBack_block4.addData('fixation.started', fixation.tStartRefresh)
    loop_nBack_block4.addData('fixation.stopped', fixation.tStopRefresh)
    loop_nBack_block4.addData('letter_text.started', letter_text.tStartRefresh)
    loop_nBack_block4.addData('letter_text.stopped', letter_text.tStopRefresh)
    # check responses
    if response_nBack.keys in ['', [], None]:  # No response was made
        response_nBack.keys = None
        # was no response the correct answer?!
        if str(corrAns).lower() == 'none':
           response_nBack.corr = 1;  # correct non-response
        else:
           response_nBack.corr = 0;  # failed to respond (incorrectly)
    # store data for loop_nBack_block4 (TrialHandler)
    loop_nBack_block4.addData('response_nBack.keys',response_nBack.keys)
    loop_nBack_block4.addData('response_nBack.corr', response_nBack.corr)
    if response_nBack.keys != None:  # we had a response
        loop_nBack_block4.addData('response_nBack.rt', response_nBack.rt)
    loop_nBack_block4.addData('response_nBack.started', response_nBack.tStartRefresh)
    loop_nBack_block4.addData('response_nBack.stopped', response_nBack.tStopRefresh)
    thisExp.nextEntry()
    
# completed 1.0 repeats of 'loop_nBack_block4'

# get names of stimulus parameters
if loop_nBack_block4.trialList in ([], [None], None):
    params = []
else:
    params = loop_nBack_block4.trialList[0].keys()
# save data for this loop
loop_nBack_block4.saveAsExcel(filename + '.xlsx', sheetName='loop_nBack_block4',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])
loop_nBack_block4.saveAsText(filename + 'loop_nBack_block4.csv', delim=',',
    stimOut=params,
    dataOut=['n','all_mean','all_std', 'all_raw'])

# ------Prepare to start Routine "thanks"-------
continueRoutine = True
# update component parameters for each repeat
msg = "Thanks for participating in Day 1 of Clickbait– that took" + str(expClock.getTime()/60.0) + "minutes in total. See you tomorrow!"
text.setText(msg)
# keep track of which components have finished
thanksComponents = [text]
for thisComponent in thanksComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
thanksClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "thanks"-------
while continueRoutine:
    # get current time
    t = thanksClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=thanksClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text* updates
    if text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        text.frameNStart = frameN  # exact frame index
        text.tStart = t  # local t and not account for scr refresh
        text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text, 'tStartRefresh')  # time at next scr refresh
        text.setAutoDraw(True)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in thanksComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "thanks"-------
for thisComponent in thanksComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('text.started', text.tStartRefresh)
thisExp.addData('text.stopped', text.tStopRefresh)
# the Routine "thanks" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
if eyetracker:
    eyetracker.setConnectionState(False)
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
